﻿/*
   Author: Mikko Vestola
   http://www.mvnet.fi
   mvnet@mvnet.fi

   ==========================================
   
    This file is part of Suomen sääennuste widget.

    Suomen sääennuste widget is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Suomen sääennuste widget is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Suomen sääennuste widget.  If not, see <http://www.gnu.org/licenses/>.	

   ==========================================

    Suomen sääennuste -widgetti:    
    Widgetti näyttää paikallissääennusteen
    Iltatieteen laitoksen verkkosivulta.

*/

// Tulostetaanko debug-ikkunaan tietoja sääennusteen latauksesta
var debug = false;

// Sääennusteen kuvan URL-osoitteen URL-olio
var urlObj = new URL();

var picture_url  = widget.getLocalizedString("url");;
var picture_language = widget.getLocalizedString("language");;


// Ilmatieteen laitoksen verkkosivujen lukemista varten tarvittava XMLHTTP-olio
var xmlhttp;


// Määritellään kaupunki-olio (Town-olio), kaupungilla on nimi ja sen kuvatiedoston alkuosoite
function Town(name, imageStart)
{
	this.name=name;
	this.imageStart=imageStart;
}

// Luodaan taulukko ja lisätään sinne kaupunki-olioita
var towns = new Array()

towns[0] = new Town("Alajärvi", "gram_5d_"+picture_language+"_Alajarvi");
towns[1] = new Town("Asikkala", "gram_5d_"+picture_language+"_Asikkala");
towns[2] = new Town("Enontekiö", "gram_5d_"+picture_language+"_Enontekio");
towns[3] = new Town("Espoo", "gram_5d_"+picture_language+"_Espoo");
towns[4] = new Town("Föglö", "gram_5d_"+picture_language+"_Foglo");
towns[5] = new Town("Haapavesi", "gram_5d_"+picture_language+"_Haapavesi");
towns[6] = new Town("Hailuoto", "gram_5d_"+picture_language+"_Hailuoto");
towns[7] = new Town("Halsua", "gram_5d_"+picture_language+"_Halsua");
towns[8] = new Town("Hammarland", "gram_5d_"+picture_language+"_Hammarland");
towns[9] = new Town("Hanko", "gram_5d_"+picture_language+"_Hanko");
towns[10] = new Town("Heinola", "gram_5d_"+picture_language+"_Heinola");
towns[11] = new Town("Helsinki", "gram_5d_"+picture_language+"_Helsinki");
towns[12] = new Town("Hyvinkää", "gram_5d_"+picture_language+"_Hyvinkaa");
towns[13] = new Town("Hämeenlinna", "gram_5d_"+picture_language+"_Hameenlinna");
towns[14] = new Town("Iisalmi", "gram_5d_"+picture_language+"_Iisalmi");
towns[15] = new Town("Ilomantsi", "gram_5d_"+picture_language+"_Ilomantsi");
towns[16] = new Town("Inari", "gram_5d_"+picture_language+"_Inari");
towns[17] = new Town("Inkoo", "gram_5d_"+picture_language+"_Inkoo");
towns[18] = new Town("Joensuu", "gram_5d_"+picture_language+"_Joensuu");
towns[19] = new Town("Jokioinen", "gram_5d_"+picture_language+"_Jokioinen");
towns[20] = new Town("Joutsa", "gram_5d_"+picture_language+"_Joutsa");
towns[21] = new Town("Juuka", "gram_5d_"+picture_language+"_Juuka");
towns[22] = new Town("Juupajoki", "gram_5d_"+picture_language+"_Juupajoki");
towns[23] = new Town("Juva", "gram_5d_"+picture_language+"_Juva");
towns[24] = new Town("Jyväskylä", "gram_5d_"+picture_language+"_Jyvaskyla");
towns[25] = new Town("Jämsä", "gram_5d_"+picture_language+"_Jamsa");
towns[26] = new Town("Kajaani", "gram_5d_"+picture_language+"_Kajaani");
towns[27] = new Town("Kalajoki", "gram_5d_"+picture_language+"_Kalajoki");
towns[28] = new Town("Kankaanpää", "gram_5d_"+picture_language+"_Kankaanpaa");
towns[29] = new Town("Kauhajoki", "gram_5d_"+picture_language+"_Kauhajoki");
towns[30] = new Town("Kemi", "gram_5d_"+picture_language+"_Kemi");
towns[31] = new Town("Kemijärvi", "gram_5d_"+picture_language+"_Kemijarvi");
towns[32] = new Town("Kemiönsaari", "gram_5d_"+picture_language+"_Kemionsaari");
towns[33] = new Town("Kilpisjärvi", "gram_5d_"+picture_language+"_Kilpisjarvi");
towns[34] = new Town("Kirkkonummi", "gram_5d_"+picture_language+"_Kirkkonummi");
towns[35] = new Town("Kittilä", "gram_5d_"+picture_language+"_Kittila");
towns[36] = new Town("Kokemäki", "gram_5d_"+picture_language+"_Kokemaki");
towns[37] = new Town("Kokkola", "gram_5d_"+picture_language+"_Kokkola");
towns[38] = new Town("Korsnäs", "gram_5d_"+picture_language+"_Korsnas");
towns[39] = new Town("Kotka", "gram_5d_"+picture_language+"_Kotka");
towns[40] = new Town("Kouvola", "gram_5d_"+picture_language+"_Kouvola");
towns[41] = new Town("Kristiinankaupunki", "gram_5d_"+picture_language+"_Kristiinankaupunki");
towns[42] = new Town("Kuhmo", "gram_5d_"+picture_language+"_Kuhmo");
towns[43] = new Town("Kumlinge", "gram_5d_"+picture_language+"_Kumlinge");
towns[44] = new Town("Kuopio", "gram_5d_"+picture_language+"_Kuopio");
towns[45] = new Town("Kustavi", "gram_5d_"+picture_language+"_Kustavi");
towns[46] = new Town("Kuusamo", "gram_5d_"+picture_language+"_Kuusamo");
towns[47] = new Town("Lahti", "gram_5d_"+picture_language+"_Lahti");
towns[48] = new Town("Lappeenranta", "gram_5d_"+picture_language+"_Lappeenranta");
towns[49] = new Town("Lieksa", "gram_5d_"+picture_language+"_Lieksa");
towns[50] = new Town("Lohja", "gram_5d_"+picture_language+"_Lohja");
towns[51] = new Town("Luhanka", "gram_5d_"+picture_language+"_Luhanka");
towns[52] = new Town("Länsi-Turunmaa", "gram_5d_"+picture_language+"_Lansi-Turunmaa");
towns[53] = new Town("Maaninka", "gram_5d_"+picture_language+"_Maaninka");
towns[54] = new Town("Maarianhamina", "gram_5d_"+picture_language+"_Maarianhamina");
towns[55] = new Town("Mikkeli", "gram_5d_"+picture_language+"_Mikkeli");
towns[56] = new Town("Multia", "gram_5d_"+picture_language+"_Multia");
towns[57] = new Town("Muonio", "gram_5d_"+picture_language+"_Muonio");
towns[58] = new Town("Naantali", "gram_5d_"+picture_language+"_Naantali");
towns[59] = new Town("Nivala", "gram_5d_"+picture_language+"_Nivala");
towns[60] = new Town("Nurmes", "gram_5d_"+picture_language+"_Nurmes");
towns[61] = new Town("Nurmijärvi", "gram_5d_"+picture_language+"_Nurmijarvi");
towns[62] = new Town("Oulu", "gram_5d_"+picture_language+"_Oulu");
towns[63] = new Town("Parikkala", "gram_5d_"+picture_language+"_Parikkala");
towns[64] = new Town("Pelkosenniemi", "gram_5d_"+picture_language+"_Pelkosenniemi");
towns[65] = new Town("Pello", "gram_5d_"+picture_language+"_Pello");
towns[66] = new Town("Pernaja", "gram_5d_"+picture_language+"_Pernaja");
towns[67] = new Town("Pietarsaari", "gram_5d_"+picture_language+"_Pietarsaari");
towns[68] = new Town("Pori", "gram_5d_"+picture_language+"_Pori");
towns[69] = new Town("Porvoo", "gram_5d_"+picture_language+"_Porvoo");
towns[70] = new Town("Pudasjärvi", "gram_5d_"+picture_language+"_Pudasjarvi");
towns[71] = new Town("Punkaharju", "gram_5d_"+picture_language+"_Punkaharju");
towns[72] = new Town("Puumala", "gram_5d_"+picture_language+"_Puumala");
towns[73] = new Town("Pyhäjärvi", "gram_5d_"+picture_language+"_Pyhajarvi");
towns[74] = new Town("Raahe", "gram_5d_"+picture_language+"_Raahe");
towns[75] = new Town("Raasepori", "gram_5d_"+picture_language+"_Raasepori");
towns[76] = new Town("Ranua", "gram_5d_"+picture_language+"_Ranua");
towns[77] = new Town("Rauma", "gram_5d_"+picture_language+"_Rauma");
towns[78] = new Town("Rautavaara", "gram_5d_"+picture_language+"_Rautavaara");
towns[79] = new Town("Rovaniemi", "gram_5d_"+picture_language+"_Rovaniemi");
towns[80] = new Town("Ruukki", "gram_5d_"+picture_language+"_Ruukki");
towns[81] = new Town("Saariselkä", "gram_5d_"+picture_language+"_Saariselka");
towns[82] = new Town("Salla", "gram_5d_"+picture_language+"_Salla");
towns[83] = new Town("Salo", "gram_5d_"+picture_language+"_Salo");
towns[84] = new Town("Savonlinna", "gram_5d_"+picture_language+"_Savonlinna");
towns[85] = new Town("Savukoski", "gram_5d_"+picture_language+"_Savukoski");
towns[86] = new Town("Seinäjoki", "gram_5d_"+picture_language+"_Seinajoki");
towns[87] = new Town("Sodankylä", "gram_5d_"+picture_language+"_Sodankyla");
towns[88] = new Town("Sotkamo", "gram_5d_"+picture_language+"_Sotkamo");
towns[89] = new Town("Suomussalmi", "gram_5d_"+picture_language+"_Suomussalmi");
towns[90] = new Town("Taipalsaari", "gram_5d_"+picture_language+"_Taipalsaari");
towns[91] = new Town("Taivalkoski", "gram_5d_"+picture_language+"_Taivalkoski");
towns[92] = new Town("Tampere", "gram_5d_"+picture_language+"_Tampere");
towns[93] = new Town("Tohmajärvi", "gram_5d_"+picture_language+"_Tohmajarvi");
towns[94] = new Town("Tornio", "gram_5d_"+picture_language+"_Tornio");
towns[95] = new Town("Turku", "gram_5d_"+picture_language+"_Turku");
towns[96] = new Town("Utsjoki", "gram_5d_"+picture_language+"_Utsjoki");
towns[97] = new Town("Uusikaupunki", "gram_5d_"+picture_language+"_Uusikaupunki");
towns[98] = new Town("Vaasa", "gram_5d_"+picture_language+"_Vaasa");
towns[99] = new Town("Vantaa", "gram_5d_"+picture_language+"_Vantaa");
towns[100] = new Town("Varkaus", "gram_5d_"+picture_language+"_Varkaus");
towns[101] = new Town("Vihti", "gram_5d_"+picture_language+"_Vihti");
towns[102] = new Town("Viitasaari", "gram_5d_"+picture_language+"_Viitasaari");
towns[103] = new Town("Virolahti", "gram_5d_"+picture_language+"_Virolahti");
towns[104] = new Town("Virrat", "gram_5d_"+picture_language+"_Virrat");
towns[105] = new Town("Ylitornio", "gram_5d_"+picture_language+"_Ylitornio");
towns[106] = new Town("Ylivieska", "gram_5d_"+picture_language+"_Ylivieska");
towns[107] = new Town("Ähtäri", "gram_5d_"+picture_language+"_Ahtari");


// Mikä kaupungeista on valittuna (oletuksena ei mikään)
var selected = -1;

/*
 * Luodaan taulukko ponnahdusvalikkoa varten.  Lisätään taulukkoon towns-taulukon kaikki kaupungit MenuItem-olioina.
 * Kun ponnahdusvalikosta valitaan kohde (onSelect), suoritetaan changeTown-funktio, joka saa parametrikseen taulukon indeksin.
 */
var items = new Array();
var i;

for (i=0; i<towns.length; i++) {
	items[i] = new MenuItem();
	items[i].title = towns[i].name;
	items[i].onSelect = "changeTown("+i+");";
	items[i].enabled = true;
}


/*
 *  Lokalisoi ohjelman. Käännökset eri kielille löytyvät Resources-kansiosta.
*/
function localize() {

	preferences.updateInterval.title = widget.getLocalizedString("updateInterval_title");
	preferences.updateInterval.description = widget.getLocalizedString("updateInterval_description");
	
	preferences.headsUp.title = widget.getLocalizedString("headsUp_title");
	preferences.headsUp.description = widget.getLocalizedString("headsUp_description");
	
	preferences.manually.title = widget.getLocalizedString("manually_title");
	preferences.manually.description = widget.getLocalizedString("manually_description");

	preferences.townSelected.title = widget.getLocalizedString("townSelected_title");
	preferences.townSelected.description = widget.getLocalizedString("townSelected_description");
	
	headingTop.data = widget.getLocalizedString("window_title_top");	
	headingBottom.data = widget.getLocalizedString("window_title_bottom");

	Day_label.data = widget.getLocalizedString("Day_label");
	Night_label.data = widget.getLocalizedString("Night_label");
	
	lastUpdated.data = widget.getLocalizedString("lastUpdated")+"N/A";
	
	picture_url  = widget.getLocalizedString("url");
	picture_language = widget.getLocalizedString("language");
}

/*
 * Päivittää asetukset.
 */
function updatePreferences()
{
	// Jos on valittu, että sääennuste päivitetään vain heijastusnäytön avautuessa, pysäytetään ajastin
	if (preferences.headsUp.value == 1 || preferences.manually.value == 1)
		timer1.ticking = false;
	else
		timer1.ticking = true;
		
	// Asetetaan ajastimen päivitysväliksi se, mikä asetuksiin on annettu (muunnetaan sekunneista minuuteiksi)
	timer1.interval = preferences.updateInterval.value*60;
	
	// Jos valittua kaupunkia on muutettu asetuksista
	if (selected != preferences.townSelected.value) {
		
		// Jos kyseessä ei ole ohjelman 1. käynnistys (selected=-1)
		if(selected>=0)
			items[selected].checked = false;
		
		// Päivitetään valittu kaupunki, ponnahdusvalikon valittu kohde, kaupungin nimi ja päivitetään sääennuste
		selected = preferences.townSelected.value;
		items[selected].checked = true;
		townName.data = towns[selected].name;
		updateWeather();
	}	
	
}

/*
 * Vaihtaa valitun kaupungin indeksin parametrina saaduksi indeksiksi ja päivittää sääennusteen. 
 * Tätä funktiota käytetään ponnahdusvalikon kohteiden kanssa.
 */
function changeTown(index) {

	// Otetaan ensin ponnahdusvalikosta pois vanhan valitun kaupungin ruksi
	items[selected].checked = false;
	
	// Päivitetään valitun kaupungin indeksi ja päivitetään myös asetuksiin, koska muutos ei tapahtunut asetuksista
	selected = index;
	items[selected].checked = true;
	preferences.townSelected.value = selected;
	
	// Päivitetään kaupunkin nimi ja sääennuste
	townName.data = towns[selected].name;
	updateWeather();

}

// Näyttää ponnahdusvalikon, jossa on listattu kaikki kaupungit.
function chooseTown() {

	popupMenu(items, system.event.hOffset, system.event.vOffset);
	
}


/* Päivittää sääennusteen (feidaa kuvan ulos ja näyttää spinner-kuvan) */
function updateWeather() {

	// Päivitä-ikonin kuvan muuttaminen 
	if (refresh.src != "Images/refresh.png")
		refresh.src = "Images/refresh_mouseclick.png";

	// Feidaa kuva ulos ja näytä spinner-kuva
	if (weatherImage.src != "Images/loading.png")
		fadeOut(weatherImage);
	
	spinner.visible = true;

	// Lataa uusi sääennuste-kuva
	loadImage();

}


/* Tekee objektista läpinäkyvämmän */
function fadeOut(textObject) {
	animator.start(new FadeAnimation(textObject, 100, 600, animator.kEaseOut));
}

/* Poistaa objektin läpinäkyvyyden */
function fadeIn(textObject) {
	animator.start(new FadeAnimation(textObject, 255, 1000, animator.kEaseOut));
}

/* Asettaa päivitä-ikonin mouseover-tilaan */
function refreshIconOver() {
	refresh.src = "Images/refresh_mouseover.png";
}

/* Asettaa päivitä-ikonin normaaliin tilaan */
function refreshIconExit() {
	refresh.src = "Images/refresh.png";
}

/* Asettaa päivitä-ikonin mouseover-tilaan (tai jättää sen normaaliin tilaan) kun käyttäjä on päästänyt hiiren painikkeen */
function refreshIconUp() {
	if (refresh.src != "Images/refresh.png")
		refresh.src = "Images/refresh_mouseover.png";
}

/* Suoritetaan, kun heijastusnäyttö avataan */
function konsposeActivated() {
	// Sääennuste ladataan aina uudestaan, jos vain manuaalista päivitystä ei ole asetettu
	if (preferences.manually.value != 1)
		updateWeather();
}

/* Asettaa kaupungin nimi -tekstin mouseover-tilaan (eri värinen teksti) */
function townNameOver() {
	townName.color = "#C0FFC0";
}

/* Asettaa kaupungin nimi -tekstin normaaliin tilaan */
function townNameExit() {
	townName.color = "#FFFFFF";
}


/*
 * Funktio, joka suoritetaan, kun asynkroninen fetch on suoritettu parametrin URL-oliolle (kuvan hakeminen palvelimelta)
 */ 
function fetchDone(urlObj) {

	weatherImage.src = urlObj.outputFile;
	weatherImage.reload();
	
	// Asetetaan sarjakuvan osoite äsken luetuksi ja sijoitetaan se hieman eri paikkaan
	weatherImage.clipRect = "32, 12, 325, 111";
	weatherImage.hOffset = 25;
	weatherImage.vOffset = 28;
	
	fadeIn(weatherImage);
	spinner.visible = false;

	if (debug)
		print("Fetch: "+urlObj.location);
	
	// Lasketaan tämänhetkinen päiväys ja kellonaika
	var currentTime = new Date();
	var month = currentTime.getMonth() + 1
	var day = currentTime.getDate();
	var year = currentTime.getFullYear();
	var hour = currentTime.getHours();
	var min = currentTime.getMinutes();
	var sec = currentTime.getSeconds();
	
	var dayNumber = currentTime.getDay();
	var dayName = "";
	
	if (dayNumber==1)
		dayName = widget.getLocalizedString("day_Mon");
	else if (dayNumber==2)
		dayName = widget.getLocalizedString("day_Tue");
	else if (dayNumber==3)
		dayName = widget.getLocalizedString("day_Wed");
	else if (dayNumber==4)
		dayName = widget.getLocalizedString("day_Thu");
	else if (dayNumber==5)
		dayName = widget.getLocalizedString("day_Fri");
	else if (dayNumber==6)
		dayName = widget.getLocalizedString("day_Sat");
	else if (dayNumber==0)
		dayName = widget.getLocalizedString("day_Sun");

	// Tunnit, minuutit ja sekunnit halutaan näyttää aine kahdella numerolla.
	if (hour < 10)
		hour = "0"+hour;
	if (min < 10)
		min = "0"+min;
	if (sec < 10)
		sec = "0"+sec;
	
	// Päivitetään "Viimeksi päivitetty"-kentän arvo vastaamaan aikaleimaa
	lastUpdated.data = widget.getLocalizedString("lastUpdated")+dayName+" "+
	day+"."+month+"."+year+" "+hour+":"+min+":"+sec;
		
}


/*
 * Lataa kuvan sääennusteesta Ilmatieteen laitoksen sivuilta ja laittaa sen näkyville widgettiin.
 */ 
function loadImage() {
   
   // Luodaan uusi http-yhteys, jolla haetaan tietoa palvelimelta
   xmlhttp = new XMLHttpRequest();
   xmlhttp.setRequestHeader("Cache-Control", "no-cache");
   
   // Määritellään funktio, joka suoritetaan, kun http-yhteyden tila muuttuu (itse funktion rakenne on määritelty alla)
   xmlhttp.onreadystatechange=state_Change;
  
  // Tästä osoitteesta haetaan tietoa. Sivulta löytyy 5 päivän sääennusteen -kuvan osoite, jota tarvitaan
  var url = picture_url + towns[selected].name;
   
  // Avataan yhteys palvelimelle edellä määriteltyyn osoitteeseen ja lähetetään pyyntö palvelimelle.
  xmlhttp.open("GET", url, true);
  xmlhttp.send(null);
  
  // Tätä funktiota kutsutaan, kun http-yhteyden tila muuttuu
  function state_Change() {
	
		// Http-yhteyden tila 4 vastaa sitä, että palvelimelta on saatu vastaus. Muista tiloista ei välitetä.
		if (xmlhttp.readyState==4) {

			/* 
			 * Palvelimelta on saatu vastaus. Tarkastetaan vastaako vastaus sitä, että sivun lataus on onnistunut (200 OK).
			 * Vastaukseksi voitaisiin saada myös esim. 404 Not Found, jos sivua ei löydy. Nyt tehdään jotain vain, jos sivun lataus onnisui.
			*/
			if (xmlhttp.status==200) {
			
				// Otetaan ylös palvelimelta saatu vastaus, joka on siis ladattu sivu
				var response=xmlhttp.responseText;
				
				// Etsitään sivusta kohta, josta alkaa sääennusteen kuvan osoite.
		        var start = response.indexOf(towns[selected].imageStart);
					         				
				// Luetaan äsken etsitystä kohdasta eteenpäin merkkejä niin paljon, että saadaan luettua kuvan osoite
				// Kuvan osoite on aina muotoa: <picture_url>/gram_5d_<picture_language>_Espoo_2006120814_2006120719.gif
				var imgSrc = response.substring(start, start+towns[selected].name.length+37);

				// Jos debug-moodi on päällä, tulostetaan ilmoituksia debug-ikkunaan
				if (debug)
					print ("Loaded image: "+imgSrc);
				
				// Luodaan URL-olio
				urlObj = new URL();
				
				// Määritetään, mihin kuva tallennetaan, kun se on haettu (nopeuttaa huomattavasti)
				urlObj.outputFile = system.widgetDataFolder + "/suomensaaennuste";
				
				// Asetetaan siistitty URL-osoite URL-oliolle
				urlObj.location = "http://www.fmi.fi/img/saa/paikallissaa/"+imgSrc;
				
				// Haetaan kuva asynkronisesti (ei jää odottamaan kuvan latautumista vaan siirtyy eteenpäin)
				urlObj.fetchAsync(fetchDone);
			
			} else {
				// Sivun lataus epäonnistui, kerrotaan käyttäjälle
				lastUpdated.data = widget.getLocalizedString("error");
				spinner.visible = false;
				fadeIn(weatherImage);
			}
		}
	}
      
}

/* Tämä suoritetaan, kun widgetti suljetaan */
function closeAll() {

	// Pysäytä kaikki lataaminen
	urlObj.cancel();
	xmlhttp.abort();

}
